<!DOCTYPE html>
<html>
    <head>

    </head>
    <body>
        <script>
            var b1="global_variable1";
            var obj1={
                b1 : "scoped_to_obj1",
                fun1 : function(){              //Normal function this is scoped with in the object it was created
                    document.write("fun1 : "+this.b1);
                    },
                fun2 : () => {
                    document.write("</br>fun2 : "+this.b1);     //arrow function returns global variables
                }
                };
            obj1.fun1();
            obj1.fun2();

            var obj2={
                b2 : "scoped_to_obj2",
                fun1 : function(){              //here b1 and fun1 are scoped to obj2 hence it prints scoped_to_obj2
                    document.write("</br>fun1 : "+this.b2);
                    },
                fun2 : () => {
                    document.write("</br>fun2 : "+this.b2);//as there is no global variable it prints undefined;
                }
                };
                obj2.fun1();
                obj2.fun2();

            var obj3={
                b3 : "scoped_to_obj3",
                fun1 : function(){  
                    var b3="scoped_to_fun1";            
                    document.write("</br>fun1 : "+this.b3); //this is scoped to obj3 hence it prints "scoped_to_fun1"
                    document.write("</br>fun1 : "+b3);      //here b2 is local variable it prints "scoped_to_fun1" 
                    },
                fun2 : () => {
                    document.write("</br>fun2 : "+this.b3);  //as there is no global variable it prints "undefined";
                            }
                };
                obj3.fun1();
                obj3.fun2();

            var obj4={
                b4 : "scoped_to_obj4",
                fun1 : function(){  
                    b4="b4_in_fun1";            
                    document.write("</br>fun1 : "+this.b4); //this is scoped to obj3 hence it prints "scoped_to_fun1"
                    document.write("</br>fun1 : "+b4);      //here b4 takes globally bcoz declaration of b is not done.
                    },
                fun2 : () => {
                    document.write("</br>fun2 : "+this.b4);  //b4 is global and initialized in fun1 hence prints "b4_in_fun1" 
                            }
                };
                obj4.fun1();
                obj4.fun2();

            b5="global_variable_b5";
            var obj5={
                b5 : "scoped_to_obj5",
                fun1 : function(){  
                    b5="b5_in_fun1";            
                    document.write("</br>fun1 : "+this.b5); //this is scoped to obj5 hence it prints "scoped_to_obj5"
                    document.write("</br>fun1 : "+b5);      //here local b5 is accessed 
                    },
                fun2 : () => {
                    document.write("</br>fun2 : "+this.b5); //global b5
                    document.write("</br>fun2 : "+b5);      //global b5
                            }
                };  
                obj5.fun1();
                obj5.fun2();

                b6="global_variable_b6";
            var obj6={
                b6 : "scoped_to_obj5",
                fun1 : function(){  
                    b6="b6_in_fun1";                        //global b6 value changes            
                    document.write("</br>fun1 : "+this.b6); //this is scoped to obj5 hence it prints "scoped_to_obj5"
                    document.write("</br>fun1 : "+b6);      //here local b5 is accessed 
                    },
                fun2 : () => {
                    b6="globalb6_in_fun2";                  //global b6 value changes
                    document.write("</br>fun2 : "+this.b6); //global b6
                    document.write("</br>fun2 : "+b6);      //global b6
                            }
                };  
                obj6.fun1();
                obj6.fun2();
            var b7="global_b7";
            var obj7={
                b7 : "scoped_to_obj7",
                fun1 : function(){              
                    document.write("</br>fun1 : "+this.b7); //this is scoped to obj7 hence it prints "scoped_to_obj7"
                    document.write("</br>fun1 : "+b7);      //here b7 in obj7 is accessed 
                    },
                fun2 : () => {
                    var b7="b7_in_fun2";                  //locally b7 is initialized
                    document.write("</br>fun2 : "+this.b7); //global b7
                    document.write("</br>fun2 : "+b7);      //local b7
                            }
                };  
                obj7.fun1();
                obj7.fun2();

            b8="global_b8";
            function f11()
            {
                var b8="local_b8_to_f11";
                document.write("</br>f11 : "+this.b8);// global b8
                f12();
                function f12()
                {
                    document.write("</br>f12 : "+this.b8);//global b8
                    document.write("</br>f12 : "+b8);
                }
            }
            f11();

            b9="global_b9";
            function f21()
            {
                var b9="local_b9_to_f1";
                document.write("</br>f21 : "+this.b9);//global b9
                var f22=()=>
                {
                    document.write("</br>f22 : "+this.b9);//gobal b9
                    document.write("</br>f22 : "+b9);//local b9 in f21 ...access parent scope
                }
                f22();
            }
            f21();

            b10="global b10";
            var f31=()=>{
                var b10="arrow b10";
                document.write("</br>f31 : "+this.b10);
                document.write("</br>f31 : "+b10);
                f32();
                function f32()
                {
                    document.write("</br>f32 : "+this.b10)
                    document.write("</br>f32 : "+b10);
                }
            
            }
            f31();

            b11="global_b11";
            var f43=()=>{document.write("</br>f43 : "+this.b11)}
            function f41()
            {
                var b11="local_to_41";
                document.write("</br>f41 : "+this.b11);
                f42();
                function f42()
                {
                    document.write("</br>f42 : "+this.b11);
                    f43();
                }

            }
            f41();

        function f51()
        {
            var a=2;
            document.write("</br>f51 : "+this.a);
            function f52()
            {
                a=3;
                document.write("</br>f52 : "+this.a)
            }
            f52();
        }
        f51();
            

        </script>
    </body>
</html>